<template>
    <div>
        <section class="hero">
            <div class="hero-body">
                <p class="title">
                    Contestant portal
                </p>
            </div>
        </section>
        <section class="section">
            <h3 class="title">Team {{ currentTeamEmoji }}</h3>
            <p class="block">
                {{ currentTeamMessage }}
            </p>
            <b-button
                class="button block"
                v-if="currentTeamName"
                label="Show team code"
                type="is-primary"
                @click="alertTeamCode"/>
            <div v-if="currentTeamName">
                <h5 class="title is-5">Submission history</h5>
                <b-table
                    :data="teamData"
                    :columns="teamColumns"
                    sort-icon="arrow-up"
                    paginated
                    @sort="sortTable"
                    backend-sorting
                    per-page="5"
                    :default-sort="['date', 'desc']">
                </b-table>
            </div>
        </section>
        <section class="section">
            <h3 class="title">Actions</h3>
            <p v-if="!isEmailConfirmed" class="block">
                Actions are unavailable until you confirm your email.
            </p>
            <div v-if="blackoutDateArray.length !== 0">
                <p>Submissions are blocked during these times:</p>
                <p v-for="(range, i) in blackoutDateArray" :key="i">
                    {{ formatDate(range[0]) }} to {{ formatDate(range[1]) }}
                </p>
                <br>
            </div>
            <b-field>
                <b-tooltip
                    :label="isContestInfoExist ? 'Download files provided by the administrators' : 'This file isn\'t available right now'"
                    position='is-right'>
                <b-button
                    tag="a"
                    href="/api/attachment/download"
                    type="is-info"
                    :disabled="!(isContestInfoExist && isEmailConfirmed)"
                    download>
                    Contest files
                </b-button>
                </b-tooltip>
            </b-field>
            <b-field>
                <b-tooltip
                    :label="isTeamSubmissionExist ? 'Download your team\'s most recent submission' : 'Your team hasn\'t submitted yet'"
                    position='is-right'>
                <b-button
                    tag="a"
                    href="/api/submissions/team"
                    type="is-info"
                    :disabled="!(isTeamSubmissionExist && isEmailConfirmed)"
                    download>
                    Team submission
                </b-button>
                </b-tooltip>
            </b-field>
            <b-field>
                <b-tooltip
                    :label="isGameFilmExist ? 'Download your team\'s most recent game film' : 'Game film not available'"
                    position='is-right'>
                <b-button
                    tag="a"
                    href="/api/user/gamefilm/download"
                    type="is-info"
                    :disabled="!(isGameFilmExist && isEmailConfirmed)"
                    download>
                    Game film
                </b-button>
                </b-tooltip>
            </b-field>
            <b-field grouped class="file is-primary" :class="{'has-name': !!file}">
                <b-tooltip
                    :label="isEmailConfirmed ? 'Upload a .zip file' : 'Please confirm your email before uploading'"
                    position='is-right'>
                    <b-upload
                        v-model="file"
                        class="file-label"
                        accept='.zip'
                        @input="checkFileSize"
                        :disabled="!isEmailConfirmed"
                    >
                        <span class="file-cta">
                            <b-icon class="file-icon" icon="upload"></b-icon>
                            <span class="file-label">Upload submission</span>
                        </span>
                        <span class="file-name" v-if="file">
                            {{ cleanFileName }}
                        </span>
                    </b-upload>
                </b-tooltip>
                <b-tooltip
                    :label="isEmailConfirmed ? 'Uploading a new submission will overwrite any old ones' : 'Please confirm your email before uploading'"
                    position='is-right'>
                    <b-button
                        class="is-success"
                        @click="recaptcha('execute')"
                        :loading="isUploadLoading"
                        :disabled="!isEmailConfirmed"
                    >Submit</b-button>
                </b-tooltip>
            </b-field>
        </section>
        <section class="section">   
            <h3 class="title">Contest Documentation</h3>
            <markdown-it-vue-light class="md-body" :content="contestDescription" :options="markdownOptions" />
        </section>
        <b-modal v-model="isProgressModalActive" :width="640" :can-cancel="false">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-header-title">Upload progress</h4>
                </div>
                <div class="card-content">
                    <p class="block">{{ uploadMessage }}</p>
                    <b-progress class="block" :value="uploadProgress" show-value format="percent"></b-progress>
                    <div class="block" v-if="showUploadCancel">
                        <b-button type="is-danger" @click="cancelUpload">Cancel</b-button>
                    </div>
                </div>
            </div>
        </b-modal>
        <b-modal v-model="isConfirmEmailModalActive" :width="640" :on-cancel="openEmailSnack">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-header-title">Email confirmation</h4>
                </div>
                <div class="card-content">
                    <p class="block">
                        You're registration is almost complete!
                        We've sent you an email with a confirmation code.
                        You have until {{ emailExpireDate }} to confirm your registration.
                        Please enter the code below:
                    </p>
                    <b-field grouped>
                        <b-numberinput v-model="emailConfirmCode" :controls="false"></b-numberinput>
                        <b-button type="is-primary" @click="sendEmailConfirm">Confirm</b-button>
                    </b-field>
                    <p class="block">
                        Not seeing an email?  Check your spam or junk folders.  If you still can't find it, you can request a new email by clicking the button below.
                    </p>
                    <b-button type="is-ghost" @click="resendEmail" :disabled="resendEmailDisabled">Resend email</b-button>
                    <p class="block">
                        Still having trouble?  <a href="mailto:bob.lee@wbi-innovates.com">Contact us.</a>
                    </p>
                </div>
            </div>
        </b-modal>
        <vue-recaptcha
            :sitekey="recaptchaKey"
            @verify="recaptcha('verify', $event)"
            @expired="recaptcha('expired', null)"
            @error="recaptcha('error', null)"
            ref="recaptcha"
            size="invisible"
        >
        </vue-recaptcha>
    </div>
</template>

<script>
 import MarkdownItVueLight from 'markdown-it-vue/dist/markdown-it-vue-light.umd.min.js'
 import 'markdown-it-vue/dist/markdown-it-vue-light.css'
 import VueRecaptcha from 'vue-recaptcha'
 export default {
     name: 'ContestantPortal',
     components: { MarkdownItVueLight, 'vue-recaptcha': VueRecaptcha },
     data() {
         return {
             isAdmin: false,
             file: null,  // user contest submission
             cleanFileName: '',
             contestDescription: '',  // see backend/contest-description.js
             isUploadLoading: false,
             isProgressModalActive: false,
             xhr: null,  // global XMLHTTPRequest
             uploadProgress: 0,  // percent of upload
             uploadMessage: '',
             showUploadCancel: true,
             currentTeamName: '',
             currentTeamCode: '',
             currentTeamEmoji: '',
             teamColumns: [
                 { field: 'username', label: 'Username', sortable: true },
                 { field: 'name', label: 'Name', sortable: true },
                 { field: 'date', label: 'Date (local)', sortable: true }
             ],
             teamData: [],
             markdownOptions: {
                 markdownIt: {
                     linkify: true,
                     typographer: true
                 }
             },
             isContestInfoExist: false,
             isTeamSubmissionExist: false,
             isGameFilmExist: false,
             isEmailConfirmed: false,
             recaptchaKey: process.env.VUE_APP_RECAPTCHA_SITE_KEY,
             blackoutDateArray: [],
             isConfirmEmailModalActive: false,
             emailExpireDate: '',
             emailConfirmCode: null,
             resendEmailDisabled: false
         }
     },
     computed: {
         currentTeamMessage() {
             return this.currentTeamName ? `You're currently a member of the team ${this.currentTeamName}.` : "You're not a member of a team. Your submissions won't be counted if you're not in a team, so please contact the administrators."
         }
     },
     methods: {
         recaptcha(event, token) {
             if (event === 'verify') {
                 this.$refs.recaptcha.reset()
                 this.postSubmission(token)
             } else if (event === 'expired') {
                 this.$refs.recaptcha.reset()
             } else if (event === 'error') {
                 this.toastWrong('recaptcha error');
                 this.$refs.recaptcha.reset()
             } else if (event === 'execute') {
                 this.$refs.recaptcha.execute()
             }
         },
         getContestDescription() {
             // GET contestDescription from API
             fetch('/api/contest-description/info')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             this.contestDescription = res.contestDescription
                             return   
                         })
                     }
                 })
                 .catch((e) => { console.error(e) })
         },
         checkFileSize() {
             if (!this.file) {
                 return
             }
             // remove <>& from file name before render (actually changing
             // file name will happen in backend)
             this.cleanFileName = this.file.name.replace(/[<>&]/g, '')
             if (this.file.size > 6000000000) {
                 // 6 gigabytes
                 let size = Math.floor(this.file.size / 100000000) / 10
                 this.file = null
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: `File too big (${size} GB out of limit 6 GB)`,
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
             }
         },
         cancelUpload() {
             this.xhr.abort()
         },
         postSubmission(recaptchaToken) {
             // send submission file to server
             if (this.isUploadLoading) {
                // prevents additional clicks
                 return
             } else {
                 this.isUploadLoading = true
             }

             if (this.isInBlackout()) {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: "Submissions aren't allowed at this time",
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
                 this.isUploadLoading = false
                 return
             }

             if (!this.file) {
                 this.isUploadLoading = false
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'No file selected for upload',
                     position: 'is-bottom',
                     type: 'is-danger'
                 })
                 return
             }

             this.uploadMessage = "Uploading " + this.cleanFileName
             this.isProgressModalActive = true
             
             let form = new FormData()
             form.append('submission', this.file)
             form.append('recaptchaToken', recaptchaToken)
             this.xhr = new XMLHttpRequest()  // not fetch so we can track progress
             // listen for `upload.load` event
             this.xhr.upload.onload = () => {
                 // upload finished (still need to copy file)
                 this.showUploadCancel = false
                 this.uploadProgress = null  // indeterminate progress
                 this.uploadMessage = "Upload done; cleaning up (this might take a while)"
             }
             this.xhr.onload = () => {
                 // response finished (completely done)
                 this.isUploadLoading = false
                 this.isProgressModalActive = false
                 if (this.xhr.status === 200) {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'File successfully uploaded',
                         position: 'is-bottom',
                         type: 'is-success',
                         queue: false
                     })
                     this.getTeamMembers()  // refresh submissions table
                 } else {
                     this.$refs.recaptcha.reset()
                     if (this.xhr.status === 429) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "You've made too many requests. Please wait before submitting again",
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                         return
                     }
                     if (this.xhr.status === 405) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "The server detected that this isn't a zip file. Please properly compress and try again",
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                         return
                     }
                     if (this.xhr.status === 503) {
                         // admin is processing submissions, or we're in a blackout
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "Submissions aren't allowed at this time",
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                     }
                     if (this.xhr.status === 404) {
                         // isInTeam middleware failed
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "You're not in a team, so submissions are blocked. Please contact an admin",
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         });
                     }
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Error in file upload',
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     })
                 }
             }
             // listen for `upload.error` event
             this.xhr.upload.onerror = () => {
                 this.$refs.recaptcha.reset()
                 this.isUploadLoading = false
                 this.isProgressModalActive = false
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'Error in file upload',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
             }
             // listen for `upload.abort` event
             this.xhr.upload.onabort = () => {
                 this.$refs.recaptcha.reset()
                 this.isUploadLoading = false
                 this.isProgressModalActive = false
                 this.$buefy.toast.open({
                     duration: 2000,
                     message: 'Upload cancelled',
                     position: 'is-bottom',
                     type: 'is-warning'
                 })
             }
             // listen for `progress` event
             this.xhr.upload.onprogress = (event) => {
                 // event.loaded returns how many bytes are downloaded
                 // event.total returns the total number of bytes
                 // truncate progress to the tenths place
                 this.uploadProgress = Math.trunc(1000 * event.loaded / event.total) / 10
             }
             this.xhr.open('POST', '/api/user/submit')
             this.xhr.send(form)
         },
         getTeamInfo() {
             // get team at identifier. if idType is 'id', we get the team
             // with team_id === identifier. if idType is 'team_code', we get the
             // team with team_code === identifier
             fetch('/api/teams/info/user')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             this.currentTeamName = res.name
                             this.currentTeamCode = res.team_code
                             this.currentTeamEmoji = res.emoji
                         })
                         .catch((e) => {
                             this.toastWrong(e)
                         })
                     } else if (response.status === 404) {
                         this.$buefy.toast.open({
                             message: "You're not in a team, so you aren't able to submit. Please contact an admin to get you on a team.",
                             duration: 3000,
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         });
                     } else {
                         this.toastWrong('getTeamInfo error');
                     }
                 })
                 .catch((e) => {
                     this.toastWrong(e)
                 })
         },
         getTeamMembers() {
             fetch('/api/teams/members')
             .then((response) => {
                 if (response.ok) {
                     response.json().then((res) => {
                         let data = []
                         let members = res.members
                         for (let i=0; i<members.length; i++) {
                             let row = {}
                             row.username = members[i].username
                             row.name = members[i].first_name + ' ' + members[i].last_name
                             if (members[i].created_at) {
                                 row.date = new Intl.DateTimeFormat([], {
                                     dateStyle: 'medium',
                                     timeStyle: 'short'
                                 }).format(new Date(members[i].created_at))
                             } else {
                                 row.date = "(none)"
                             }
                             data.push(row)
                         }
                         this.teamData = data
                         this.sortTable('date', 'desc')  // sort by date, most recent first
                         return
                     })
                     .catch((e) => {
                         this.toastWrong(e)
                     })
                 } else if (response.status === 404) {
                     this.$buefy.toast.open({
                         message: "You're not in a team, so you aren't able to submit. Please contact an admin to get you on a team.",
                         duration: 3000,
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     });
                 } else {
                     this.toastWrong('getTeamMembers error');
                 }
             })
             .catch((e) => {
                 this.toastWrong(e)
             })
         },
         checkContestInfoExists() {
             fetch('/api/attachment/exists')
                 .then((response) => {
                     if (response.ok) {
                         this.isContestInfoExist = true
                     } else if (response.status === 404) {
                         this.isContestInfoExist = false
                     } else if (response.status === 500) {
                         this.toastWrong('checkContestInfoExists error');
                     }
                 })
                 .catch((e) => { this.toastWrong(e) })
         },
         checkTeamSubmissionExists() {
             fetch('/api/submissions/team/exists')
                 .then((response) => {
                     if (response.ok) {
                         this.isTeamSubmissionExist = true
                     } else if (response.status === 404) {
                         this.isTeamSubmissionExist = false
                     } else if (response.status === 500) {
                         this.toastWrong('checkTeamSubmissionExists error');
                     }
                 })
                 .catch((e) => { this.toastWrong(e) })
         },
         checkGameFilmExists() {
             // check if the backend has a game film file for this team
             fetch('/api/user/gamefilm/exists')
                 .then(response => {
                     if (response.ok) {
                         this.isGameFilmExist = true;
                     } else if (response.status === 404) {
                         this.isGameFilmExist = false;
                     } else {
                         this.toastWrong('checkGameFilmExists error');
                     }
                 })
                 .catch((e) => this.toastWrong(e));
         },
         toastWrong(e) {
             if (e) {
                 console.error(e)
             }
             this.$buefy.toast.open({
                 duration: 3000,
                 message: 'Something went wrong',
                 position: 'is-bottom',
                 type: 'is-danger',
                 queue: false
             })
         },
         sortTable(field, order) {
             // custom sorting for table
             let modOrder = (order === 'asc') ? 1 : -1
             if (field !== 'date') {
                 // normal alphabetical sorting
                 this.teamData.sort((a, b) => { return (a[field] > b[field]) ? modOrder : (a[field] < b[field]) ? -modOrder : 0 })
             } else {
                 // date sorting
                 this.teamData.sort((a, b) => {
                     return (new Date(a.date) - new Date(b.date)) * modOrder
                 })
             }
         },
         alertTeamCode() {
             this.$buefy.dialog.alert({
                 title: `Team code for ${this.currentTeamName}`,
                 message: `${this.currentTeamCode}`
             })
         },
         checkEmailConfirmed() {
             fetch('/api/user/confirmed')
                 .then((response) => {
                     if (response.ok) {
                         this.isEmailConfirmed = true
                         return
                     } else if (response.status === 444) {
                         response.json().then((expires) => {
                             this.isEmailConfirmed = false
                             let expireDate = new Intl.DateTimeFormat([], {
                                 dateStyle: 'full',
                                 timeStyle: 'long'
                             }).format(new Date(expires.expires))
                             this.emailExpireDate = expireDate;
                             this.isConfirmEmailModalActive = true;
                         })
                     } else {
                         this.toastWrong('checkEmailConfirmed error');
                     }
                 })
                 .catch((e) => { this.toastWrong(e) })
         },
         openEmailSnack() {
             this.$buefy.snackbar.open({
                 message: "Email not confirmed",
                 type: 'is-warning',
                 position: 'is-bottom-right',
                 actionText: 'Confirm',
                 indefinite: true,
                 onAction: () => this.isConfirmEmailModalActive = true
             });
         },
         sendEmailConfirm() {
             fetch(`/confirm/${this.emailConfirmCode}`)
                 .then(response => {
                     if (response.ok) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: 'Successfully confirmed',
                             position: 'is-bottom',
                             type: 'is-success',
                             queue: false
                         })
                         this.isEmailConfirmed = true;
                         this.isConfirmEmailModalActive = false;
                     } else if (response.status === 404) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "We couldn't find that code",
                             position: 'is-bottom',
                             type: 'is-warning',
                             queue: false
                         })
                     } else {
                         this.toastWrong('Error in sendEmailCOnfirm');
                     }
                 })
                 .catch((e) => { this.toastWrong(e); });
         },
         resendEmail() {
             this.resendEmailDisabled = true;
             fetch('/api/user/email/resend')
                 .then(response => {
                     if (response.ok) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "Resent. Please check your email (including spam folders)",
                             position: 'is-bottom',
                             type: 'is-success',
                             queue: false
                         });
                     } else {
                         this.toastWrong('Error in resendEmail');
                     }
                     this.resendEmailDisabled = false;
                 })
                 .catch(e => this.toastWrong(e));
         },
         getBlackoutDates() {
             fetch('/api/user/blackout')
                 .then(response => response.json())
                 .then((json) => {
                     this.blackoutDateArray = json.blackoutDates
                 }).catch((e) => this.toastWrong(e))
         },
         formatDate(date) {
             date = new Date(date)
             let options = {
                 year: 'numeric',
                 month: 'short',
                 day: 'numeric',
                 hour: 'numeric',
                 minute: 'numeric',
                 timeZoneName: 'short'
             }
             return new Intl.DateTimeFormat([], options).format(date)
         },
         isInBlackout() {
             // not computed because new Date() is expensive: this means we don't disable the button
             if (this.isAdmin) {
                 // admin can upload whenever
                 return false
             }
             let currentDate = new Date()
             for (let i=0; i<this.blackoutDateArray.length; i++) {
                 if (currentDate > new Date(this.blackoutDateArray[i][0]) && currentDate < new Date(this.blackoutDateArray[i][1])) {
                     // isAfter and isBefore compare by default to now
                     return true
                 }
             }
             return false
         },
         getAdmin() {
             // check if current user is admin (for allowing upload during blackout)
             // admin endpoints and uploading during blackouts is protected on backend
             fetch('/api/admin/authed')
                 .then(response => {
                     if (response.ok) {
                         this.isAdmin = true
                     } else {
                         this.isAdmin = false
                     }
                 })
                 .catch(e => {
                     this.toastWrong(e);
                 })
         }
     },
     mounted() {
         this.checkEmailConfirmed()
         this.getContestDescription()
         this.getTeamInfo()
         this.getTeamMembers()
         this.checkContestInfoExists()
         this.checkTeamSubmissionExists()
         this.checkGameFilmExists()
         this.getBlackoutDates()
         this.getAdmin()
         this.$emit('login')  // so navbar updates on register
     }
 }
</script>
